"""
DO NOT EDIT THIS FILE!!
This file is automatically generated by the process_schemas.py program
in the scripts directory. It is not intended to be edited directly. If
you need to update the GEL protocol classes, please run the script
on the appropriate schema version.
"""
from protocols.protocol import (
    ProtocolElement,
    avro_parse,
    load_schema,
)


class SelectionEvent(ProtocolElement):
    """
    SelectionEvent =================================== A set of result
    data relating to a specific set of checks performed
    """

    # load schema from file
    _schemaSource = load_schema(__file__)
    # parse into avro classes
    schema = avro_parse(_schemaSource)

    requiredFields = {
        "description",
        "name",
        "passed",
    }

    @classmethod
    def getEmbeddedTypes(cls):
        return {}

    @classmethod
    def getEmbeddedEnums(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_8_0 import metrics as metrics_1_2_3

        return {
            "name": metrics_1_2_3.SelectionTest,
        }

    @classmethod
    def getEmbeddedByNamespace(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_8_0 import metrics as metrics_1_2_3

        return {
            "org.gel.models.metrics.avro.SelectionTest": metrics_1_2_3.SelectionTest,
            "org.gel.models.metrics.avro.SelectionEvent": metrics_1_2_3.SelectionEvent,
        }

    __slots__ = [
        "description",
        "name",
        "passed",
        "flags",
    ]

    def __init__(
        self,
        description,
        name,
        passed,
        flags=None,
        validate=None,
        **kwargs
    ):
        """Initialise the metrics_1_2_3.SelectionEvent model.

        :param description:
            List of descriptive strings relating to test execution
        :type description: list[str]
        :param name:
            Name of the test performed during this event
        :type name: SelectionTest
        :param passed:
            Whether the test passed or failed
        :type passed: boolean
        :param flags:
            List of flags raised during test execution
        :type flags: None | list[str]
        """

        attributes = {k: v for k, v in locals().items() if k not in ["self", "unknown"]}
        ProtocolElement.__init__(self, **attributes)

    @classmethod
    def _namespace_version(cls):
        return "1.2.3"
